// protocol.cpp : implementation file
//

#include "stdafx.h"
#include "nstest.h"
#include "protocol.h"
#include "ddeobj.h"
#include "nstesdoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProtocolHandler

IMPLEMENT_DYNCREATE(CProtocolHandler, CCmdTarget)

CProtocolHandler::CProtocolHandler()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	
	AfxOleLockApp();
	
	//	Create an empty document that we can interact with.
	m_pDoc = (CNstestDoc *)((CNstestApp *)AfxGetApp())->OpenDocumentNew();
	if(m_pDoc == NULL)	{
		AfxThrowOleException(E_UNEXPECTED);
	}

	//	We'll want the user to see this new document.
	//	Doesn't matter if we're hidden or in the back ground,
	//		bring us up to the front.
	AfxGetApp()->m_pMainWnd->ShowWindow(SW_SHOW);
}

CProtocolHandler::~CProtocolHandler()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	
	AfxOleUnlockApp();
}

void CProtocolHandler::OnFinalRelease()
{
	// When the last reference for an automation object is released
	//	OnFinalRelease is called.  This implementation deletes the 
	//	object.  Add additional cleanup required for your object before
	//	deleting it from memory.

	delete this;
}


BEGIN_MESSAGE_MAP(CProtocolHandler, CCmdTarget)
	//{{AFX_MSG_MAP(CProtocolHandler)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CProtocolHandler, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CProtocolHandler)
	DISP_FUNCTION(CProtocolHandler, "Initialize", Initialize, VT_I2, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CProtocolHandler, "Open", Open, VT_EMPTY, VTS_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

IMPLEMENT_OLECREATE(CProtocolHandler, "Nstest.Protocol.1", 0x37ff8638, 0x64a9, 0x11ce, 0x8c, 0xe4, 0x0, 0x20, 0xaf, 0x18, 0xf9, 0x5)

/////////////////////////////////////////////////////////////////////////////
// CProtocolHandler message handlers


short CProtocolHandler::Initialize(LPCTSTR pProtocol, LPCTSTR pUrl) 
{
	// TODO: Add your dispatch handler code here
	short sRetval = 1;
	
	char aBuf[512];
	sprintf(aBuf, "OLE %d CProtocolHandler::Initialize(%s,%s);", sRetval, pProtocol, pUrl);
	m_pDoc->Display(aBuf);
	
	//	Deny or accept.
	return sRetval;
}

void CProtocolHandler::Open(LPCTSTR pUrl) 
{
	// TODO: Add your dispatch handler code here

	char aBuf[2048];
	sprintf(aBuf, "OLE void CProtocolHandler::Open(%s);", pUrl);
	m_pDoc->Display(aBuf);
	
	//	Do custom processing for this URL here, perhaps calling
	//		Netscape back for network loading or whatever....
}
